﻿using ExcelLibrary.LoadXLSM.Models;
using Infragistics.Documents.Excel;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System.Diagnostics;
using System.IO;
using System.Linq;

namespace ExcelLibrary.LoadXLSM.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private readonly IWebHostEnvironment _hostingEnvironment;

        public HomeController(ILogger<HomeController> logger, IWebHostEnvironment hostingEnvironment)
        {
            _logger = logger;
            _hostingEnvironment = hostingEnvironment;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public ActionResult LoadFile()
        {
            string filePath = Path.Combine(_hostingEnvironment.WebRootPath, "File.xlsm");

            FileStream fileStream = new FileStream(filePath, FileMode.Open);

            Workbook workbook = Workbook.Load(fileStream);
            string workSheetName = workbook.Worksheets.First().Name;

            fileStream.Close();

            return Json(new { name = workSheetName });
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}